------------------------------------------------
-- "VRay Subdivs Optimizer beta1"
--
-- Author: Sitnikov Ivan aka "vansan"
-- Created On: 30/06/07 for VRay 1.5 RC4
-- tested using: 3dsmax 9.2
------------------------------------------------

-- Description:
--
------------------------------------------------
Max_subdivs_value = 32
q_f = 1


fn quality_setup scene_mat =
(
print "VrayMtl ok"
if classof scene_mat == vraymtl then
	(
	if scene_mat.brdf_type == 0 and scene_mat.reflection_glossiness != 1 then
		(
-------------Reflection------------
		if scene_mat.reflection_glossiness >= 0.85 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 60 * q_f)
		else if scene_mat.reflection_glossiness >= 0.825 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 65 * q_f)
		else if scene_mat.reflection_glossiness >= 0.8 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 75 * q_f)
		else if scene_mat.reflection_glossiness >= 0.7875 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 82 * q_f)
		else if scene_mat.reflection_glossiness >= 0.775 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 86 * q_f)
		else if scene_mat.reflection_glossiness >= 0.7625 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 90 * q_f)
		else if scene_mat.reflection_glossiness >= 0.75 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 96 * q_f)
		else if scene_mat.reflection_glossiness >= 0.7375 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 100 * q_f)
		else if scene_mat.reflection_glossiness >= 0.725 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 102 * q_f)
		else if scene_mat.reflection_glossiness >= 0.7125 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 100 * q_f)
		else if scene_mat.reflection_glossiness >= 0.7 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 100 * q_f)
		else if scene_mat.reflection_glossiness >= 0.6875 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 85 * q_f)
		else if scene_mat.reflection_glossiness >= 0.675 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 85 * q_f)
		else if scene_mat.reflection_glossiness >= 0.65 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 88 * q_f)
		else if scene_mat.reflection_glossiness >= 0.625 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 84 * q_f)
		else if scene_mat.reflection_glossiness >= 0.6 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 84 * q_f)
		else if scene_mat.reflection_glossiness >= 0.55 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 88 * q_f)
		else if scene_mat.reflection_glossiness >= 0.5 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 91 * q_f)
		else if scene_mat.reflection_glossiness < 0.5 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 95 * q_f)
		if scene_mat.reflection_subdivs >= Max_subdivs_value then scene_mat.reflection_subdivs = Max_subdivs_value
-------------Refraction------------
		if scene_mat.refraction_glossiness >= 0.85 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 60 * q_f)
		else if scene_mat.refraction_glossiness >= 0.825 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 65 * q_f)
		else if scene_mat.refraction_glossiness >= 0.8 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 75 * q_f)
		else if scene_mat.refraction_glossiness >= 0.7875 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 82 * q_f)
		else if scene_mat.refraction_glossiness >= 0.775 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 86 * q_f)
		else if scene_mat.refraction_glossiness >= 0.7625 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 90 * q_f)
		else if scene_mat.refraction_glossiness >= 0.75 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 96 * q_f)
		else if scene_mat.refraction_glossiness >= 0.7375 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 100 * q_f)
		else if scene_mat.refraction_glossiness >= 0.725 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 102 * q_f)
		else if scene_mat.refraction_glossiness >= 0.7125 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 100 * q_f)
		else if scene_mat.refraction_glossiness >= 0.7 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 100 * q_f)
		else if scene_mat.refraction_glossiness >= 0.6875 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 85 * q_f)
		else if scene_mat.refraction_glossiness >= 0.675 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 85 * q_f)
		else if scene_mat.refraction_glossiness >= 0.65 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 88 * q_f)
		else if scene_mat.refraction_glossiness >= 0.625 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 84 * q_f)
		else if scene_mat.refraction_glossiness >= 0.6 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 84 * q_f)
		else if scene_mat.refraction_glossiness >= 0.55 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 88 * q_f)
		else if scene_mat.refraction_glossiness >= 0.5 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 91 * q_f)
		else if scene_mat.refraction_glossiness < 0.5 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 95 * q_f)
		if scene_mat.refraction_subdivs >= Max_subdivs_value then scene_mat.refraction_subdivs = Max_subdivs_value

	)
	if scene_mat.brdf_type == 1 and scene_mat.reflection_glossiness != 1 then --ready!
		(
-------------Reflection------------
		if scene_mat.reflection_glossiness > 0.8 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 100 * q_f)
		else if scene_mat.reflection_glossiness > 0.775 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 105 * q_f)
		else if scene_mat.reflection_glossiness > 0.75 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 110 * q_f)
		else if scene_mat.reflection_glossiness > 0.7375 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 115 * q_f)
		else if scene_mat.reflection_glossiness > 0.725 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 120 * q_f)
		else if scene_mat.reflection_glossiness > 0.7125 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 125 * q_f)
		else if scene_mat.reflection_glossiness > 0.7 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 130 * q_f)
		else if scene_mat.reflection_glossiness > 0.6875 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 135 * q_f)
		else if scene_mat.reflection_glossiness > 0.675 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 140 * q_f)
		else if scene_mat.reflection_glossiness > 0.65 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 150 * q_f)
		else if scene_mat.reflection_glossiness > 0.625 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 145 * q_f)
		else if scene_mat.reflection_glossiness > 0.6 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 140 * q_f)
		else if scene_mat.reflection_glossiness > 0.55 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 135 * q_f)
		else if scene_mat.reflection_glossiness > 0.5 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 130 * q_f)
		else if scene_mat.reflection_glossiness < 0.5 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 125 * q_f)
		if scene_mat.reflection_subdivs >= Max_subdivs_value then scene_mat.reflection_subdivs = Max_subdivs_value
-------------Refraction------------
		if scene_mat.refraction_glossiness > 0.8 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 100 * q_f)
		else if scene_mat.refraction_glossiness > 0.775 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 105 * q_f)
		else if scene_mat.refraction_glossiness > 0.75 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 110 * q_f)
		else if scene_mat.refraction_glossiness > 0.7375 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 115 * q_f)
		else if scene_mat.refraction_glossiness > 0.725 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 120 * q_f)
		else if scene_mat.refraction_glossiness > 0.7125 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 125 * q_f)
		else if scene_mat.refraction_glossiness > 0.7 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 130 * q_f)
		else if scene_mat.refraction_glossiness > 0.6875 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 135 * q_f)
		else if scene_mat.refraction_glossiness > 0.675 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 140 * q_f)
		else if scene_mat.refraction_glossiness > 0.65 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 150 * q_f)
		else if scene_mat.refraction_glossiness > 0.625 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 145 * q_f)
		else if scene_mat.refraction_glossiness > 0.6 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 140 * q_f)
		else if scene_mat.refraction_glossiness > 0.55 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 135 * q_f)
		else if scene_mat.refraction_glossiness > 0.5 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 130 * q_f)
		else if scene_mat.refraction_glossiness < 0.5 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 125 * q_f)
		if scene_mat.refraction_subdivs >= Max_subdivs_value then scene_mat.refraction_subdivs = Max_subdivs_value
		)
	if scene_mat.brdf_type == 2 and scene_mat.reflection_glossiness != 1 then
		(
-------------Reflection------------
		if scene_mat.reflection_glossiness >= 0.99 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 800 * q_f)
		else if scene_mat.reflection_glossiness >= 0.98 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 500 * q_f)
		else if scene_mat.reflection_glossiness >= 0.97 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 466 * q_f)
		else if scene_mat.reflection_glossiness >= 0.96 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 400 * q_f)		
		else if scene_mat.reflection_glossiness >= 0.95 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 360 * q_f)
		else if scene_mat.reflection_glossiness >= 0.9 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 240 * q_f)
		else if scene_mat.reflection_glossiness >= 0.875 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 210 * q_f)
		else if scene_mat.reflection_glossiness >= 0.85 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 185 * q_f)
		else if scene_mat.reflection_glossiness >= 0.80 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 205 * q_f)
		else if scene_mat.reflection_glossiness > 0.775 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 192 * q_f)
		else if scene_mat.reflection_glossiness > 0.75 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 185 * q_f)
		else if scene_mat.reflection_glossiness > 0.7375 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 180 * q_f)
		else if scene_mat.reflection_glossiness > 0.725 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 177 * q_f)
		else if scene_mat.reflection_glossiness > 0.7125 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 173 * q_f)
		else if scene_mat.reflection_glossiness > 0.7 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 168 * q_f)
		else if scene_mat.reflection_glossiness > 0.6875 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 166 * q_f)
		else if scene_mat.reflection_glossiness > 0.675 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 164 * q_f)
		else if scene_mat.reflection_glossiness > 0.65 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 162 * q_f)
		else if scene_mat.reflection_glossiness > 0.625 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 160 * q_f)
		else if scene_mat.reflection_glossiness > 0.6 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 165 * q_f)
		else if scene_mat.reflection_glossiness > 0.55 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 165 * q_f)
		else if scene_mat.reflection_glossiness > 0.5 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 165 * q_f)
		else if scene_mat.reflection_glossiness < 0.5 then (scene_mat.reflection_subdivs = (1 - scene_mat.reflection_glossiness) * 165 * q_f)
		if scene_mat.reflection_subdivs >= Max_subdivs_value then scene_mat.reflection_subdivs = Max_subdivs_value
-------------Refraction------------
		if scene_mat.refraction_glossiness >= 0.99 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 800 * q_f)
		else if scene_mat.refraction_glossiness >= 0.98 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 500 * q_f)
		else if scene_mat.refraction_glossiness >= 0.97 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 466 * q_f)
		else if scene_mat.refraction_glossiness >= 0.96 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 400 * q_f)		
		else if scene_mat.refraction_glossiness >= 0.95 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 360 * q_f)
		else if scene_mat.refraction_glossiness >= 0.9 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 240 * q_f)
		else if scene_mat.refraction_glossiness >= 0.875 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 210 * q_f)
		else if scene_mat.refraction_glossiness >= 0.85 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 185 * q_f)
		else if scene_mat.refraction_glossiness >= 0.80 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 205 * q_f)
		else if scene_mat.refraction_glossiness > 0.775 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 192 * q_f)
		else if scene_mat.refraction_glossiness > 0.75 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 185 * q_f)
		else if scene_mat.refraction_glossiness > 0.7375 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 180 * q_f)
		else if scene_mat.refraction_glossiness > 0.725 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 177 * q_f)
		else if scene_mat.refraction_glossiness > 0.7125 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 173 * q_f)
		else if scene_mat.refraction_glossiness > 0.7 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 168 * q_f)
		else if scene_mat.refraction_glossiness > 0.6875 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 166 * q_f)
		else if scene_mat.refraction_glossiness > 0.675 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 164 * q_f)
		else if scene_mat.refraction_glossiness > 0.65 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 162 * q_f)
		else if scene_mat.refraction_glossiness > 0.625 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 160 * q_f)
		else if scene_mat.refraction_glossiness > 0.6 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 165 * q_f)
		else if scene_mat.refraction_glossiness > 0.55 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 165 * q_f)
		else if scene_mat.refraction_glossiness > 0.5 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 165 * q_f)
		else if scene_mat.refraction_glossiness < 0.5 then (scene_mat.refraction_subdivs = (1 - scene_mat.refraction_glossiness) * 165 * q_f)
		if scene_mat.refraction_subdivs >= Max_subdivs_value then scene_mat.refraction_subdivs = Max_subdivs_value		
		)
	)
)

fn mc_smart_convert scene_mat =
(	
	if classof scene_mat == multimaterial then
		(
		for i=1 to scene_mat.numsubs do
		mc_smart_convert scene_mat[i]
		)
	if classof scene_mat == vrayblendmtl then
		(
		quality_setup scene_mat[1]
		for i=1 to 9 do
		quality_setup scene_mat.coatMtl[i]
		)
	if classof scene_mat == VRayMtlWrapper then
		(
		quality_setup scene_mat.baseMtl
		)
	if classof scene_mat == VRay2SidedMtl then
		(
		quality_setup scene_mat.frontMtl
		quality_setup scene_mat.backMtl
		)
	if classof scene_mat == VRayOverrideMtl then
		(
		quality_setup scene_mat.baseMtl
		quality_setup scene_mat.giMtl
		quality_setup scene_mat.reflectMtl
		quality_setup scene_mat.refractMtl		
		)
		else (quality_setup scene_mat)
		
)	
	
fn mc_scene_smart_convert scene_mat =
(
	for scene_mat in scenematerials do
	(
		if classof scene_mat == multimaterial then
		(
		for i=1 to scene_mat.numsubs do
		mc_smart_convert scene_mat[i]
		)
		else (mc_smart_convert scene_mat)
	)
)

fn mc_selection_smart_convert scene_mat =
(
	for scene_mat in selection do
	(
		if classof scene_mat == multimaterial then
		(
		for i=1 to scene_mat.numsubs do
		mc_smart_convert scene_mat[i]
		)
		else (mc_smart_convert scene_mat)
	)
)

fn mc_matlib_smart_convert scene_mat =
(
	for scene_mat in currentMaterialLibrary do
	(
		if classof scene_mat == multimaterial then
		(
		for i=1 to scene_mat.numsubs do
		mc_smart_convert scene_mat[i]
		)
		else (mc_smart_convert scene_mat)
	)
)


rollout mc_rollout "Vray Subdivs Optimizer"
	(
group "Scene Materials"
	(
		radiobuttons objectselection labels:#("Current MatEd Slot", "Material Library", "Selected Objects", "Entire Scene")pos:[10,20] default:1
		button select_ml "Choose Mat. Library..." enabled:false pos:[14,84] width:110
		spinner max_subdivs "Max Subdivs " range:[1,100,32] type:#integer pos:[180,21] width:59
		spinner quality_factor "Subdivs Mult. " range:[0.05,10,1] type:#float pos:[170,46] width:69 scale:0.05
		editText matlib_name_text "" enabled:false pos:[10,112]
		button ProcessMaterials "Process Materials" enabled:true width:190
	)

--group "Scene Lights"
--	(
--		button ProcessLights "Process Lights" enabled:true width:190
--	)
group "About"
	(
		label lbl0 "VRay Subdivs Optimizer beta1"
		label lbl00 "-------------------------------------------------------------"
		label lbl1 "This script is for personal"
		label lbl2 "and non-commercial use only."
		label lbl3 "(c) 2007"
		label lbl4 "written by Ivan Sitnikov (vansan)"
		label lbl5 "vansan@list.ru"		
	)
	
	on max_subdivs changed value do Max_subdivs_value = value
	on quality_factor changed value do q_f = value

	on objectselection changed state do
	(
		if objectselection.state == 2 then
		(
			matlib_name_text.text = "Open MatEd window slows processing!"
			select_ml.enabled = true
			saveMaterialLibrary "$scripts/temp.mcc"
			print "Select material library!"
		)
		else
		(
			select_ml.enabled = false
			matlib_name_text.text = ""
			loadMaterialLibrary "$scripts/temp.mcc"
			deletefile "$scripts/temp.mcc"
		)
	)
		
		
	on convert_to_b pressed do 
	(
		mc_conv_org meditMaterials[oldSlot]
	)

	on select_ml pressed do 
		(
		fileOpenMatLib()
		matlib_name_text.text = getMatLibFileName()
		)

	on ProcessMaterials pressed do 
		(
		conv_method = case objectselection.state of 
		(
		1: 1 -- Current Slot
		2: 2 -- Material Library
		3: 3 -- Selected Objects
		4: 4 -- Entire Scene
		)

		if conv_method == 1 then 
	(
	scene_mat = meditMaterials[medit.GetActiveMtlSlot()]
	if classof scene_mat == multimaterial then
	(
	for i=1 to scene_mat.numsubs do
	mc_smart_convert scene_mat[i]
	)
	else (mc_smart_convert scene_mat)
	)

		if conv_method == 2 then 
		(
		for m=1 to currentMaterialLibrary.count do
		(
		mc_matlib_smart_convert currentMaterialLibrary[m]
		)
		matlib_name_text.text = "MatLib is processed! Save it NOW!"
		)
		
		if conv_method == 3 then 
(
		for obj in selection do
	(
		scene_mat = obj.material
		if classof scene_mat == multimaterial then
		(
		for i=1 to scene_mat.numsubs do
		mc_smart_convert scene_mat[i]
		)
		else (mc_smart_convert scene_mat)
	)
	
matlib_name_text.text = "Selected objects are processed!"
)

		if conv_method == 4 then 
		(
		mc_scene_smart_convert the_mat
		matlib_name_text.text = "Scene materials are processed!"
		)
	)
)
if mc_floater != undefined then CloseRolloutFloater mc_floater
mc_floater = newRolloutFloater "VRay Subdivs Optimizer" 265 188
addRollout mc_rollout mc_floater
------------------------------------------------